

//TODO:
// - support relative require()s
// - support index.js directory-style modules

(function() {
	var global = this;
	if(typeof(exports) === 'undefined') {
		Obligate = {};
		var exports = Obligate;
	}

	exports.extensions = ['js'];
	var filemap = {};
	exports.def = function defineModuleLoader(path, fn) {
		filemap[path] = fn;
	};

	var lookup = exports.lookup = function(filename) {
		var data = tryLookup(filename);
		if(data == null) {
			throw new Error("can't find file to require: " + filename);
		}
		return data;
	};

	function tryLookup(filename) {
		function lookup(filename) {
			return filemap[filename];
		};
		var plain = lookup(filename);
		if(plain) {
			return plain;
		}
		for(var i=0; i<exports.extensions.length; i++) {
			var extension = exports.extensions[i];
			var filename_ext = filename + '.' + extension;
			var data = lookup(filename_ext);
			if(data) {
				return data;
			}
		}
		return null;
	};

	exports.paths = function() {
		var paths = [];
		for(k in filemap) {
			if(filemap.hasOwnProperty(k)) {
				paths.push(k);
			}
		}
		return paths;
	};



	var sys = require('sjs:apollo-sys');

	exports.extensions.unshift('sjs');
	var hub = ['obligate:', {
			src: function(path) {
				path = path.replace(/^obligate:/, '');
				return {
					src: exports.lookup(path),
					loaded_from: path
				};
			}
		}
	];
	if(sys.hostenv == 'xbrowser') {
		//TODO: is this a good idea? it's more prone to clashes / confusion
		// than stubbornly sticking to only `obligate:`
		require.hubs.push(['nodejs:', 'obligate:']);
	}
	require.hubs.push(hub);

}).call(this);
