

//TODO:
// - support relative require()s
// - support index.js directory-style modules

(function() {
	var global = this;
	if(typeof(exports) === 'undefined') {
		Obligate = {};
		var exports = Obligate;
	}

	exports.extensions = ['js'];
	var filemap = {};
	exports.def = function defineModuleLoader(path, fn) {
		filemap[path] = fn;
	};

	var lookup = exports.lookup = function(filename) {
		var data = tryLookup(filename);
		if(data == null) {
			throw new Error("can't find file to require: " + filename);
		}
		return data;
	};

	function tryLookup(filename) {
		function lookup(filename) {
			return filemap[filename];
		};
		var plain = lookup(filename);
		if(plain) {
			return plain;
		}
		for(var i=0; i<exports.extensions.length; i++) {
			var extension = exports.extensions[i];
			var filename_ext = filename + '.' + extension;
			var data = lookup(filename_ext);
			if(data) {
				return data;
			}
		}
		return null;
	};

	exports.paths = function() {
		var paths = [];
		for(k in filemap) {
			if(filemap.hasOwnProperty(k)) {
				paths.push(k);
			}
		}
		return paths;
	};

	exports.install = function(extensionsOverride) {
		var existingRequire = global.require;
		if(existingRequire !== undefined) {
			oldRequire = existingRequire;
		}
		if(extensionsOverride) {
			exports.extensions = extensionsOverride;
		}
		global.require = exports.require;
	};

	var oldRequire = function(file) {
		throw new Error("Could not find file: " + file);
	};

	// standalone require() impl, if you don't want to install() it
	var req = exports.require = function(file) {
		if(!req.modules[file]) {
			var data = tryLookup(file);
			if(!data) {
				return oldRequire.apply(this, arguments);
			}
			var exports = req.modules[file] = {};
			data(exports);
		}
		return req.modules[file];
	};
	req.modules = {};



}).call(this);
